'Most of Graphix Routines are Here
'Drawing of Controls
DEFINT A-Z
'$INCLUDE: 'declare.bi'
'$INCLUDE: 'svgabc.bi'

SUB DrawBorder (X, Y, X1, Y1, cu, cf, cd)
CALL DRWFILLBOX(1, cf, X + 1, Y + 1, X1 - 1, Y1 - 1)

CALL DRWLINE(1, cu, X, Y, X1, Y)
CALL DRWLINE(1, cu, X, Y, X, Y1)

CALL DRWLINE(1, cd, X, Y1, X1, Y1)
CALL DRWLINE(1, cd, X1, Y, X1, Y1)


END SUB

SUB DrawPicto (X, Y, XL, n, UC, BC, TC, DC)

CALL DRWFILLBOX(1, BC, X + 1, Y + 1, X + XL - 1, Y + XL - 1)

CALL DRWLINE(1, UC, X, Y, X + XL, Y)
CALL DRWLINE(1, UC, X, Y, X, Y + XL)

CALL DRWLINE(1, DC, X, Y + XL, X + XL, Y + XL)
CALL DRWLINE(1, DC, X + XL, Y, X + XL, Y + XL)




SELECT CASE n
CASE 0
CASE 1  'close
CALL DRWLINE(1, TC, X + 2, Y + 2, X + XL - 2, Y + XL - 2)
CALL DRWLINE(1, TC, X + 2, Y + XL - 2, X + XL - 2, Y + 2)


IF XL > 10 THEN
CALL DRWLINE(1, TC, X + 3, Y + 2, X + XL - 2, Y + XL - 3)
CALL DRWLINE(1, TC, X + 2, Y + XL - 3, X + XL - 3, Y + 2)
CALL DRWLINE(1, TC, X + 2, Y + 3, X + XL - 3, Y + XL - 2)
CALL DRWLINE(1, TC, X + 3, Y + XL - 2, X + XL - 2, Y + 3)
END IF
CASE 2  'max

CALL DRWBOX(1, TC, X + 2, Y + 2, X + XL - 2, Y + XL - 2)

IF XL > 10 THEN
CALL DRWBOX(1, TC, X + 2, Y + 3, X + XL - 2, Y + XL - 2)
CALL DRWBOX(1, TC, X + 2, Y + 4, X + XL - 2, Y + XL - 2)
END IF
CASE 3  'Default
IF XL >= 10 THEN
CALL DRWBOX(1, TC, X + 1, Y + XL - 2, X + XL / 2 + 1, Y + XL / 2 - 2)
CALL DRWBOX(1, TC, X + XL / 2 - 2, Y + XL / 2 + 2, X + XL - 2, Y + 2)
END IF

IF XL < 10 THEN
CALL DRWBOX(1, TC, X + 1, Y + XL - 1, X + XL / 2, Y + XL / 2 - 1)
CALL DRWBOX(1, TC, X + XL / 2, Y + XL / 2, X + XL - 2, Y + 1)

END IF
CASE 4  'Min
IF XL >= 10 THEN
CALL DRWFILLBOX(1, TC, X + 2, Y + XL - 2, X + XL - 3, Y + XL - 3)
END IF
IF XL < 10 THEN
CALL DRWLINE(1, TC, X + 1, Y + XL - 1, X + XL - 2, Y + XL - 1)
END IF
CASE 5  'Galka
CALL DRWLINE(1, TC, X + 1, Y + 3, X + XL / 2 - 1, Y + XL / 2 + 1)
CALL DRWLINE(1, TC, X + 1, Y + 4, X + XL / 2 - 1, Y + XL / 2 + 2)
CALL DRWLINE(1, TC, X + XL / 2 - 1, Y + XL / 2 + 1, X + XL - 2, Y + 2)
CALL DRWLINE(1, TC, X + XL / 2 - 1, Y + XL / 2 + 2, X + XL - 2, Y + 3)

CASE 6  ' circle
CALL DRWFILLELLIPSE(1, TC, X + XL / 2, Y + XL / 2, XL / 2 - 2, XL / 2 - 2)

CASE 7  'Up
CALL DRWLINE(1, TC, X + 2, Y + XL - 3, X + XL / 2, Y + 3)
CALL DRWLINE(1, TC, X + XL / 2, Y + 3, X + XL - 2, Y + XL - 3)
CALL DRWLINE(1, TC, X + 2, Y + XL - 3, X + XL - 2, Y + XL - 3)
CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)
CASE 8  'Down
CALL DRWLINE(1, TC, X + 2, Y + 3, X + XL / 2, Y + XL - 3)
CALL DRWLINE(1, TC, X + XL / 2, Y + XL - 3, X + XL - 2, Y + 3)
CALL DRWLINE(1, TC, X + 2, Y + 3, X + XL - 2, Y + 3)
CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)

CASE 9  'Left
CALL DRWLINE(1, TC, X + 3, Y + XL / 2, X + XL - 3, Y + XL - 2)
CALL DRWLINE(1, TC, X + 3, Y + XL / 2, X + XL - 3, Y + 2)
CALL DRWLINE(1, TC, X + XL - 3, Y + XL - 2, X + XL - 3, Y + 2)
CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)

CASE 10  'Right
CALL DRWLINE(1, TC, X + 3, Y + 2, X + XL - 3, Y + XL / 2)
CALL DRWLINE(1, TC, X + XL - 3, Y + XL / 2, X + 3, Y + XL - 2)
CALL DRWLINE(1, TC, X + 3, Y + 2, X + 3, Y + XL - 2)
CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)
CASE 11  'Left\UP
CALL DRWLINE(1, TC, X + 2, Y + 2, X + 2, Y + XL - 2)
CALL DRWLINE(1, TC, X + 2, Y + 2, X + XL - 2, Y + 2)
CALL DRWLINE(1, TC, X + XL - 2, Y + 2, X + 2, Y + XL - 2)
CALL FILLAREA(X + 3, Y + 3, TC, TC)


END SELECT

END SUB

SUB MoveControl (dx, dy, n)
dx = 0
dy = 0
Xk = Xmouse
yk = Ymouse

Y = CTR(n, Rtop)
X = CTR(n, RLeft)
YL = CTR(n, ylen)
XL = CTR(n, xlen)

CALL SETVIEW(0, 0, GETMAXX, GETMAXY)


CALL mouse(MouseOn, xm, ym, lb, rb, HB)
CALL mouse(MouseOFF, xm, ym, lb, rb, HB)
''IF xm < 1 THEN xm = 1
''IF ym < 1 THEN ym = 1

DO

DO
x0 = xm
y0 = ym
CALL mouse(MouseGet, xmm, Ymm, lb, rb, HB)
ddx = xmm - Xk
ddy = Ymm - yk

xm = X + ddx
ym = Y + ddy

LOOP UNTIL (xm <> x0 OR ym <> y0 OR lb = 0)



CALL DRWPOINT(1, C1, xm0, ym0)
CALL DRWPOINT(1, C2, xm0 + XL, ym0)
CALL DRWPOINT(1, c11, xm0, ym0 + YL)
CALL DRWPOINT(1, c22, xm0 + XL, ym0 + YL)

C1 = GETPOINT(xm, ym)
C2 = GETPOINT(xm + XL, ym)
c11 = GETPOINT(xm, ym + YL)
c22 = GETPOINT(xm + XL, ym + YL)
c = 15

CALL DRWPOINT(1, c, xm, ym)
CALL DRWPOINT(1, c, xm + XL, ym)
CALL DRWPOINT(1, c, xm, ym + YL)
CALL DRWPOINT(1, c, xm + XL, ym + YL)
xm0 = xm
ym0 = ym
LOOP UNTIL lb = 0
dx = ddx
dy = ddy
END SUB

SUB resizeControl (dx, dy, n)
dx = 0
dy = 0
Xk = Xmouse
yk = Ymouse

Y = CTR(n, Rtop)
X = CTR(n, RLeft)
YL = CTR(n, ylen)
XL = CTR(n, xlen)
CALL SETVIEW(0, 0, GETMAXX, GETMAXY)

CALL mouse(MouseOn, xm, ym, lb, rb, HB)
CALL mouse(MouseOFF, xm, ym, lb, rb, HB)

DO

DO
x0 = xm
y0 = ym
CALL mouse(MouseGet, xmm, Ymm, lb, rb, HB)
ddx = xmm - Xk
ddy = Ymm - yk

xm = X + ddx
ym = Y + ddy

LOOP UNTIL (xm <> x0 OR ym <> y0 OR lb = 0)



CALL DRWPOINT(1, C1, X, Y)
CALL DRWPOINT(1, C2, xm0 + XL, Y)
CALL DRWPOINT(1, c11, X, ym0 + YL)
CALL DRWPOINT(1, c22, xm0 + XL, ym0 + YL)

C1 = GETPOINT(X, Y)
C2 = GETPOINT(xm + XL, Y)
c11 = GETPOINT(X, ym + YL)
c22 = GETPOINT(xm + XL, ym + YL)
c = 15
CALL DRWPOINT(1, c, X, Y)
CALL DRWPOINT(1, c, xm + XL, Y)
CALL DRWPOINT(1, c, X, ym + YL)
CALL DRWPOINT(1, c, xm + XL, ym + YL)
xm0 = xm
ym0 = ym
LOOP UNTIL lb = 0
dx = ddx
dy = ddy

END SUB

SUB ShowControl (Control)
IF Control > UBOUND(CTR, 1) THEN EXIT SUB
IF CTR(Control, NoRefresh) = 0 THEN
X = CTR(Control, RLeft)
Y = CTR(Control, Rtop)
X1 = CTR(Control, xlen) + X
Y1 = CTR(Control, ylen) + Y
XL = CTR(Control, xlen)
YL = CTR(Control, ylen)
BC = CTR(Control, BColor)
TC = CTR(Control, TColor)
UC = CTR(Control, UpColor)
DC = CTR(Control, DownColor)
HC = CTR(Control, HeadColor)
boc = SysBColor
Par = CTR(Control, parent)
T$ = title(Control)
L = LEN(T$) * 8
'-----------SetFont
IF CTR(Control, Font) <> CurrentFont AND CTR(Control, Font) > 0 THEN
applyfont (CTR(Control, Font))
CurrentFont = CTR(Control, Font)

END IF

IF CTR(Control, Font) = 0 THEN
FONTSYSTEM
CurrentFont = 0
END IF
'------End SetFont------------------
'k = ctr(2, Object)

OBJ = CTR(Control, Object)

IF CTR(Control, Object) <> OFOrm THEN
pa = ActiveForm(Control)
'CALL SETVIEW(ctr(pa, RLeft), ctr(pa, Rtop), ctr(pa, RLeft) + ctr(pa, xlen), ctr(pa, Rtop) + ctr(pa, ylen))

END IF
IF Control = p1 THEN

END IF
SELECT CASE OBJ

CASE OFOrm
IF CTR(Control, Visible) = 1 THEN

f = focus.OBJName

CALL DrawBorder(X, Y, X1, Y1, UC, BC, DC)
CALL SETVIEW(X, Y, X1, Y1)
IF Control = ActiveForm(f) THEN
CALL DrawBorder(X, Y, X1, Y + HSize, UC, HC, DC)
CALL PrintGFX(X + 3, Y + 2, T$, TC, HC)
ELSE
CALL DrawBorder(X, Y, X1, Y + HSize, UC, DC, DC)
CALL PrintGFX(X + 3, Y + 2, T$, TC, DC)
END IF
IF L > X1 - X - s * 9 * 2 THEN T$ = MID$(T$, 1, (X1 - X - s * 9 * 2) \ 8)


IF CTR(Control, NoClose) <> 1 THEN CALL DrawPicto(X1 - HSize, Y + 2, HSize - 2, 1, UC, 7, 0, DC)
IF CTR(Control, NoMaximize) = 1 AND CTR(Control, Borderstyle) = CFMinimize THEN
CALL DrawPicto(X1 - HSize * 2, Y + 2, HSize - 2, 2, UC, 7, 0, DC)
END IF

IF CTR(Control, NoMaximize) = 0 THEN
CALL DrawPicto(X1 - HSize * 2, Y + 2, HSize - 2, 2, UC, 7, 0, DC)

END IF



IF CTR(Control, NoMinimize) = 0 AND CTR(Control, Borderstyle) <> CFMinimize THEN
CALL DrawPicto(X1 - HSize * 3, Y + 2, HSize - 2, 4, UC, 7, 0, DC)
END IF
IF CTR(Control, NoResize) <> 1 AND CTR(Control, Borderstyle) <> CFMinimize THEN
CALL DrawPicto(X1 - 8, Y1 - 8, 8, 11, DC, 7, 0, UC)
END IF


END IF
CASE OButton
IF CTR(Control, RVisible) = 1 THEN
FH = GetFontHeight(CTR(Control, Font))

IF focus.OBJName = Control AND (focus.OBJEvent = CLMouseDown OR focus.OBJEvent = CRMouseDown) THEN

CALL DrawBorder(X, Y, X1, Y1, DC, BC, UC)
X = X + 2
Y = Y + 2
ELSE
CALL DrawBorder(X, Y, X1, Y1, UC, BC, DC)
END IF
IF L < X1 - X THEN
CALL PrintGFX(X + ((X1 - X) / 2 - L / 2), Y + ((Y1 - Y) / 2 - FH / 2), T$, TC, BC)
ELSE
yy = Y + 2
FOR i = 1 TO LEN(title(Control)) STEP (X1 - X) \ 8 - 1
s$ = MID$(title(Control), i, (X1 - X) \ 8 - 1)
CALL PrintGFX(X + 5, yy, s$, TC, BC)
yy = yy + FH
NEXT i
END IF
END IF
CASE OFrame
IF CTR(Control, RVisible) = 1 THEN
IF CTR(Control, Borderstyle) = CFRBorder THEN CALL DrawBorder(X, Y, X1, Y1, DC, BC, UC)
FH = GetFontHeight(CTR(Control, Font))

IF L < X1 - X THEN
CALL PrintGFX(X + ((X1 - X) / 2 - L / 2), Y + ((Y1 - Y) / 2 - FH / 2), T$, TC, BC)
ELSE
yy = Y + 2
FOR i = 1 TO LEN(title(Control)) STEP (X1 - X) \ 8 - 1
s$ = MID$(title(Control), i, (X1 - X) \ 8 - 1)
CALL PrintGFX(X + 5, yy, s$, TC, BC)
yy = yy + FH
NEXT i
END IF
END IF
CASE OCheckBox
IF CTR(Control, RVisible) = 1 THEN
IF CTR(Control, Borderstyle) = CFRBorder THEN CALL DrawBorder(X, Y, X1, Y1, DC, BC, UC)
FH = GetFontHeight(CTR(Control, Font))

CALL DrawPicto(X + 1, Y + 1, 8, 0, DC, BC, TC, UC)
IF CTR(Control, Value) = 1 THEN CALL DrawPicto(X + 1, Y + 1, 8, 5, DC, BC, TC, UC)
X = X + 10
IF L < X1 - X THEN
CALL PrintGFX(X + ((X1 - X) / 2 - L / 2), Y + ((Y1 - Y) / 2 - FH / 2), T$, TC, BC)
ELSE
yy = Y + 2
FOR i = 1 TO LEN(title(Control)) STEP (X1 - X) \ 8 - 1
s$ = MID$(title(Control), i, (X1 - X) \ 8 - 1)
CALL PrintGFX(X + 5, yy, s$, TC, BC)
yy = yy + 8 * s
NEXT i
END IF
END IF

CASE OOptionbox
IF CTR(Control, RVisible) = 1 THEN
IF CTR(Control, Borderstyle) = CFRBorder THEN CALL DrawBorder(X, Y, X1, Y1, DC, BC, UC)
FH = GetFontHeight(CTR(Control, Font))

CALL DrawPicto(X + 1, Y + 1, 8, 0, DC, BC, TC, UC)
IF CTR(Control, Value) = 1 THEN CALL DrawPicto(X + 1, Y + 1, 8, 6, DC, BC, TC, UC)
X = X + 10
IF L < X1 - X THEN
CALL PrintGFX(X + ((X1 - X) / 2 - L / 2), Y + ((Y1 - Y) / 2 - FH / 2) + 1, T$, TC, BC)
ELSE
yy = Y + 2
FOR i = 1 TO LEN(title(Control)) STEP (X1 - X) \ 8 - 1
s$ = MID$(title(Control), i, (X1 - X) \ 8 - 1)
CALL PrintGFX(X + 5, yy, s$, TC, BC)
yy = yy + 8 * s
NEXT i
END IF
END IF

CASE OTextBox
IF CTR(Control, RVisible) = 1 THEN
r = CTR(Control, Row)         'Y
c = CTR(Control, Col)        'X
rr = CTR(Control, rRow)
cc = CTR(Control, rCol)
vhs = CTR(Control, scrollBar)
IF vhs = 1 THEN
vs = 1: hs = 0
END IF
IF vhs = 2 THEN
vs = 0: hs = 1
END IF
IF vhs = 3 THEN
vs = 1: hs = 1
END IF
FH = GetFontHeight(CTR(Control, Font))

Txl = ((XL - 2 - 10 * vs) \ 8)
TYL = ((YL - 2 - 10 * hs) \ (FH))
IF r < 0 THEN r = 0
IF c < 0 THEN c = 0
IF rr < 1 THEN rr = 1
IF cc < 1 THEN cc = 1
CALL DRWFILLBOX(1, BC, X + 1, Y1 - 10 * hs - FH, X1 - 10 * vs, Y1 - 10 * hs)

CALL DRWLINE(1, DC, X, Y, X1, Y)
CALL DRWLINE(1, DC, X, Y, X, Y1)
CALL DRWLINE(1, UC, X, Y1, X1, Y1)
CALL DRWLINE(1, UC, X1, Y, X1, Y1)


sy = rr - r
sx = cc - c


ar = CTR(Control, TextArray)

IF ar <> 0 THEN

CTR(Control, Colls) = GetArrColls(ar)
CTR(Control, Rows) = GetArrRows(ar)

ELSE
CTR(Control, Colls) = LEN(title(Control)) + 1
CTR(Control, Rows) = 1
vs = 0
END IF

IF vs = 1 AND ar <> 0 THEN
CALL DrawBorder(X1 - 9, Y + 1, X1 - 1, Y1 - 18, UC, 8, DC)
CALL DrawPicto(X1 - 9, Y + 1, 8, 7, UC, boc, TC, DC)
CALL DrawPicto(X1 - 9, Y1 - 18, 8, 8, UC, boc, TC, DC)
IF CTR(Control, Colls) > TYL THEN
YYl# = YL - 28
yyll# = CTR(Control, Rows) * FH - FH
ko# = yyll# / YYl#
yy = ((r + 1) * FH - FH) / ko#
wyy = (TYL * FH - FH) / ko#

CALL DrawBorder(X1 - 9, yy + Y + 10, X1 - 1, yy + Y + 9 + wyy, UC, boc, DC)
END IF
END IF
IF hs = 1 AND ar <> 0 THEN
CALL DrawBorder(X + 9, Y1 - 9, X1 - 18, Y1 - 1, UC, 8, DC)
CALL DrawPicto(X + 1, Y1 - 9, 8, 9, UC, boc, TC, DC)
CALL DrawPicto(X1 - 18, Y1 - 9, 8, 10, UC, boc, TC, DC)

IF CTR(Control, Colls) > Txl THEN

XXl# = XL - 28
xxll# = CTR(Control, Colls) * 8 - 8
ko# = xxll# / XXl#

xx = ((c + 1) * 8 - 8) / ko#
wxx = (Txl * 8 - 8) / ko#

CALL DrawBorder(X + 9 + xx, Y1 - 9, X + 9 + xx + wxx, Y1 - 1, UC, boc, DC)
END IF
END IF
IF (vs = 1 OR hs = 1) AND ar <> 0 THEN
CALL DrawPicto(X1 - 9, Y1 - 9, 8, 11, UC, boc, TC, DC)
END IF

yy = Y - FH + 1
FOR i = r + 1 TO r + TYL
        yy = yy + FH
                IF i > CTR(Control, Rows) THEN
                EXIT FOR
                END IF
                IF ar <> 0 THEN s$ = GetArrS(ar, i) ELSE s$ = title$(Control)
                ss$ = MID$(s$, c + 1, Txl)
                IF i >= CTR(Control, SelSRow) AND i < rr AND (CTR(Control, NoSelect) <> 3 OR CTR(Control, NoSelect) <> 1) THEN
                bcc = TC
                tcc = BC
                ELSE
                bcc = BC
                tcc = TC
                END IF
                CALL DRWFILLBOX(1, bcc, X + 1, yy, X1 - 1 - 9 * vs, yy + FH + 1)
              
                CALL PrintGFX(X + 2, yy, ss$, tcc, bcc)
                IF CTR(Control, SelSRow) = rr AND CTR(Control, SelSCol) < cc AND rr = i AND (CTR(Control, NoSelect) <> 3 OR CTR(Control, NoSelect) <> 2) THEN
                        ss1$ = MID$(s$, CTR(Control, SelSCol), cc - CTR(Control, SelSCol))
                        IF CTR(Control, SelSCol) <= c THEN
                                ss1$ = MID$(ss$, 1, sx)
                                xst = 1
                                ELSE
                                xst = CTR(Control, SelSCol) - c
                        END IF

                        'LINE (X + 1 + xst * 8 - 8, yy)-(X + (sx) * 8 - 8, yy + FH), tc, BF
                        CALL DrawBorder(X + 1 + xst * 8 - 8, yy, X + (sx) * 8 - 8, yy + FH, TC, TC, TC)
                        CALL PrintGFX(X + 2 + xst * 8 - 8, yy, ss1$, BC, TC)
END IF
NEXT
IF ar <> 0 THEN f$ = fstr$(GetArrS(ar, rr)) ELSE f$ = title$(Control)

s$ = MID$(f$, cc, 1)
IF (focus.OBJName = Control) THEN
IF s$ = "" THEN s$ = " "
CALL PrintGFX(X + sx * 8 - 6, Y + sy * FH - FH + 1, s$, BC, TC)
END IF
END IF
'======================================================================-
CASE OListBox
IF CTR(Control, RVisible) = 1 THEN
r = CTR(Control, Row)         'Y
rr = CTR(Control, rRow)
c = CTR(Control, Col)         'Y
cc = CTR(Control, rCol)

vhs = CTR(Control, scrollBar)
IF vhs = 1 THEN
vs = 1: hs = 0
END IF
IF vhs = 2 THEN
vs = 0: hs = 1
END IF
IF vhs = 3 THEN
vs = 1: hs = 1
END IF
FH = GetFontHeight(CTR(Control, Font))

ar = CTR(Control, TextArray)
IF ar <> 0 THEN
CTR(Control, Colls) = GetArrColls(ar)
CTR(Control, Rows) = GetArrRows(ar)
ELSE
CTR(Control, Colls) = LEN(title(Control)) + 1
CTR(Control, Rows) = 1
END IF

Txl = ((XL - 2 - 10 * vs) \ 8)
TYL = ((YL - 2 - 10 * hs) \ (FH))
IF r < 0 THEN r = 0
IF rr < 1 THEN rr = 1
IF c < 0 THEN c = 0
IF cc < 1 THEN cc = 1

CALL DRWFILLBOX(1, BC, X + 1, Y1 - 10 * hs - FH, X1 - 10 * vs, Y1 - 10 * hs)

CALL DRWLINE(1, DC, X, Y, X1, Y)
CALL DRWLINE(1, DC, X, Y, X, Y1)
CALL DRWLINE(1, UC, X, Y1, X1, Y1)
CALL DRWLINE(1, UC, X1, Y, X1, Y1)

sy = rr - r

IF vs = 1 AND ar <> 0 THEN
CALL DrawBorder(X1 - 9, Y + 1, X1 - 1, Y1 - 18, UC, 8, DC)
CALL DrawPicto(X1 - 9, Y + 1, 8, 7, UC, boc, TC, DC)
CALL DrawPicto(X1 - 9, Y1 - 18, 8, 8, UC, boc, TC, DC)
IF CTR(Control, Rows) > TYL THEN
YYl# = YL - 28
yyll# = CTR(Control, Rows) * FH - FH
ko# = yyll# / YYl#
yy = ((r + 1) * FH - FH) / ko#
wyy = (TYL * FH - FH) / ko#
CALL DrawBorder(X1 - 9, yy + Y + 10, X1 - 1, yy + Y + 9 + wyy, UC, boc, DC)
END IF
END IF

IF hs = 1 AND ar <> 0 THEN
CALL DrawBorder(X + 9, Y1 - 9, X1 - 18, Y1 - 1, UC, 8, DC)
CALL DrawPicto(X + 1, Y1 - 9, 8, 9, UC, boc, TC, DC)
CALL DrawPicto(X1 - 18, Y1 - 9, 8, 10, UC, boc, TC, DC)
IF CTR(Control, Colls) > Txl THEN
XXl# = XL - 28
xxll# = CTR(Control, Colls) * 8 - 8
ko# = xxll# / XXl#
xx = ((c + 1) * 8 - 8) / ko#
wxx = (Txl * 8 - 8) / ko#
CALL DrawBorder(X + 9 + xx, Y1 - 9, X + 9 + xx + wxx, Y1 - 1, UC, boc, DC)
END IF
END IF

IF vs = 1 OR hs = 1 THEN
CALL DrawPicto(X1 - 9, Y1 - 9, 8, 11, UC, boc, TC, DC)
END IF
yy = Y - FH + 1

FOR i = r + 1 TO r + TYL
yy = yy + FH
IF i > CTR(Control, Rows) THEN
EXIT FOR
END IF
                IF ar <> 0 THEN s$ = GetArrS(ar, i) ELSE s$ = title$(Control)

IF LEN(s$) < Txl THEN s$ = s$ + SPACE$(Txl - (LEN(s$)))
ss$ = MID$(s$, c + 1, Txl)

IF i >= CTR(Control, SelSRow) AND i < rr AND (CTR(Control, NoSelect) <> 3 OR CTR(Control, NoSelect) <> 1) THEN
bcc = TC: tcc = BC
ELSE
IF i = rr AND focus.OBJName = Control THEN
bcc = TC: tcc = BC
ELSE
bcc = BC: tcc = TC
END IF
END IF
CALL DRWFILLBOX(1, bcc, X + 1, yy, X1 - 1 - 9 * vs, yy + FH + 1)

CALL PrintGFX(X + 2, yy, ss$, tcc, bcc)

NEXT

'f$ = getarrs(a, rr)
's$ = MID$(f$, cc, 1)
END IF

'---------------------------------------------------------------------------
CASE OMenu
IF CTR(Control, RVisible) = 1 THEN
xx1 = 0: xx2 = 1
DIM men(20, 1)
IF focus.OBJName = Control AND focus.OBJEvent = CLMouseDown THEN
sel = CTR(Control, Value)
ELSE
sel = 0
END IF
seln = CTR(Control, SelValue)
'sel = ctr(Control, SelValue)
FH = GetFontHeight(CTR(Control, Font))
       
        IF CTR(Control, Borderstyle) = 1 THEN
        CALL DrawBorder(X, Y, X1, Y1, UC, BC, DC)
        ELSE 'Sub ShowMenu 28
        CALL DRWFILLBOX(1, BC, X, Y, X1, Y1)
       END IF
        L = LEN(title(Control)) * 8
        a1$ = title(Control)
         yn = Y
         yn1 = Y1
         nn = 1
         nmk = 0
         lea1 = LEN(a1$)
         nnn = 1
        
         FOR n1 = 1 TO lea1
         c$ = MID$(a1$, n1, 1)
       
         IF c$ = "&" THEN
          pr$ = MID$(a1$, nn, n1 - nn)
          lp = LEN(pr$) * 8
                xn = X + nn * 8 - 8 + 7 * nmk
                xc = xn + lp + FH
              CALL DRWFILLBOX(1, BC, xn, yn, xc, yn1)
          
           
            IF nnn = sel OR nnn = seln THEN
            cup1 = DC
            cup2 = UC
                ELSE
            cup1 = UC
            cup2 = DC

                END IF
              
                CALL DRWLINE(1, cup1, xn, yn, xc, yn)
                CALL DRWLINE(1, cup1, xn, yn, xn, yn1)
           
                CALL DRWLINE(1, cup2, xn, yn1, xc, yn1)
                CALL DRWLINE(1, cup2, xc, yn, xc, yn1)
             
                CALL PrintGFX(xn + 4, Y + ((Y1 - Y) / 2 - FH / 2), pr$, TC, BC)
                men(nmk, xx1) = xn
                men(nmk, xx2) = xc
                XL = XL + lp
                 nmk = nmk + 1
                 nn = n1 + 1
        nnn = nnn + 1
      
        END IF
        pr$ = ""
        NEXT n1
END IF
'--------------------------------------------------------
CASE OVScrollBar
IF CTR(Control, RVisible) = 1 THEN
CALL DrawBorder(X, Y + XL, X1, Y1 - XL, UC, 8, DC)
CALL DrawPicto(X, Y, XL, 7, UC, BC, TC, DC)
CALL DrawPicto(X, Y1 - XL, XL, 8, UC, BC, TC, DC)
'IF ctr(Control, Colls) > TYL THEN
IF CTR(Control, MaxValue) = 0 THEN CTR(Control, MaxValue) = 1
IF CTR(Control, MinValue) > CTR(Control, Value) THEN CTR(Control, Value) = CTR(Control, MinValue)

k# = (CTR(Control, MaxValue) - CTR(Control, MinValue) + CTR(Control, VWidth)) / (YL - XL * 2 - 4)
wyy = CTR(Control, VWidth) / k#
yy = (CTR(Control, Value) - CTR(Control, MinValue)) / k# + 2

CALL DrawBorder(X, yy + Y + XL, X1, yy + Y + XL + wyy, UC, BC, DC)
END IF
CASE OHScrollBar
IF CTR(Control, RVisible) = 1 THEN
CALL DrawBorder(X + YL, Y, X1 - YL, Y1, UC, 8, DC)
CALL DrawPicto(X, Y, YL, 9, UC, BC, TC, DC)
CALL DrawPicto(X1 - YL, Y, YL, 10, UC, BC, TC, DC)

IF CTR(Control, MaxValue) = 0 THEN CTR(Control, MaxValue) = 1
k# = (CTR(Control, MaxValue) - CTR(Control, MinValue) + CTR(Control, VWidth)) / (XL - YL * 2 - 4)
wxx = CTR(Control, VWidth) / k#
xx = (CTR(Control, Value) - CTR(Control, MinValue)) / k# + 2 + YL + X
CALL DrawBorder(xx, Y, xx + wxx, Y + YL, UC, BC, DC)

END IF

CASE OBMPPicture

IF CTR(Control, RVisible) = 1 THEN
IF CTR(Control, Borderstyle) = 1 THEN CALL DrawBorder(X, Y, X1, Y1, DC, BC, UC)
CALL SETVIEW(X + 1, Y + 1, X1 - 1, Y1 - 1)

Yv = CTR(Control, rRow)
Xv = CTR(Control, rCol)

IF Yv + YL > CTR(Control, Colls) THEN YYl = CTR(Control, Colls) ELSE YYl = Yv + YL - 1
IF Xv + XL > CTR(Control, Rows) THEN XXl = CTR(Control, Rows) ELSE XXl = Xv + XL - 1
H% = CTR(Control, TextArray)

r = XMSBLKPUT(1, X - Xv + 1, Y - Yv + 1, H%)

CALL SETVIEW(0, 0, GETMAXX, GETMAXY)
END IF


END SELECT
END IF
CTR(Control, NoRefresh) = 1
END SUB

