'This module of Cyclib Library contains all its dialogs
DEFINT A-Z
'$INCLUDE: 'declare.bi'
'$INCLUDE: 'SVGaBC.bi'

FUNCTION FileOpen$ (titles$, DefPath$, DefExt$)
Path$ = DefPath$
IF Path$ = "" THEN
Path$ = GetCurDir$
END IF


REDIM Drives(25) AS STRING
CALL SplitPath(Path$, DR$, Dire$, file$, ext$)

Mx = GETMAXX
my = GETMAXY
FileOpenDlgForm = CreateForm(1, Mx / 2 - 125, my / 2 - 90, 250, 170 + Hsize, titles$)
CTR(FileOpenDlgForm, Modal) = 1

CTR(FileOpenDlgForm, NoResize) = 1
CTR(FileOpenDlgForm, NoMaximize) = 1
CTR(FileOpenDlgForm, NoMinimize) = 1

FODLGDrive = CreateControl(OFrame, 1, FileOpenDlgForm, 0, 0, 120, 20, DR$)
CTR(FODLGDrive, Borderstyle) = 1


FODLGDir = CreateControl(OListBox, 1, FileOpenDlgForm, 0, 25, 120, 95, "")
CTR(FODLGDir, TextArray) = NewArray(100, 13)
CTR(FODLGDir, scrollBar) = 1
CTR(FODLGDir, NoSelect) = 3
title(FODLGDir) = Dire$


FODLGDirArr = CTR(FODLGDir, TextArray)
CALL GetDirs(DR$ + Dire$, FODLGDirArr)

FODLGFile = CreateControl(OListBox, 1, FileOpenDlgForm, 125, 0, 120, 120, "")
CTR(FODLGFile, TextArray) = NewArray(100, 13)
CTR(FODLGFile, scrollBar) = 1
CTR(FODLGFile, NoSelect) = 3


FODLGFileArr = CTR(FODLGFile, TextArray)
CALL GetFiles(DR$ + Dire$, FODLGFileArr, DefExt$)

FODLGLabel1 = CreateControl(OFrame, 1, FileOpenDlgForm, 0, 125, 50, 18, "Name:")
FODLGlabel2 = CreateControl(OFrame, 1, FileOpenDlgForm, 0, 145, 50, 18, "Mask:")

FODLGName = CreateControl(OTextBox, 1, FileOpenDlgForm, 50, 125, 115, 18, deffile$)
title(FODLGName) = file$ + ext$

FODLGType = CreateControl(OTextBox, 1, FileOpenDlgForm, 50, 145, 115, 18, DefExt$)


IF ext$ <> "" THEN
title(FODLGType) = "*" + ext$
ELSEIF DefExt$ <> "" THEN
title(FODLGType) = "*" + DefExt$
ELSE
title(FODLGType) = "*.*"
END IF
CALL GetFiles(DR$ + Dire$, FODLGFileArr, title(FODLGType))


FODLGOKButton = CreateControl(OButton, 1, FileOpenDlgForm, 180, 125, 60, 18, "OK")
FODLGCancelButton = CreateControl(OButton, 1, FileOpenDlgForm, 180, 145, 60, 18, "Cancel")
'--------------------------
RegisterNewForm (FileOpenDlgForm)
CALL ExecutePrgEvent(Xk, yk, FileOpenDlgForm, CFLoad)
moff
DO

LoadForms

iv = waitforEvent
IF iv <> CKeyPress THEN
n = selectAllFocus
END IF

CALL ExecutePrgEvent(Xk, yk, n, iv)
'-----------------------Events---------------------
IF n = FODLGDir AND iv = CLMouseDBLClick THEN
rr = CTR(n, rRow)
s$ = fstr(GetArrS(FODLGDirArr, rr))
D$ = fstr$(title(FODLGDir))
DR$ = fstr$(title(FODLGDrive))

IF s$ <> ".." THEN
p$ = D$ + s$
ELSE
p$ = ""
FOR i = LEN(D$) - 1 TO 1 STEP -1
C$ = MID$(D$, i, 1)
IF C$ = "\" THEN
p$ = MID$(D$, 1, i)
s$ = ""

EXIT FOR
END IF
NEXT
END IF

IF RIGHT$(DR$ + p$, 1) <> "\" THEN p$ = p$ + "\"
CALL GetDirs(DR$ + p$, FODLGDirArr)
CALL GetFiles(DR$ + p$, FODLGFileArr, title(FODLGType))
title(FODLGDir) = p$
title(FODLGName) = ""
Refresh FileOpenDlgForm
END IF

IF n = FODLGFile AND iv = CLMouseClick THEN
rr = CTR(n, rRow)
s$ = fstr$(GetArrS(FODLGFileArr, rr))
D$ = fstr$(title(FODLGDir))
DR$ = fstr$(title(FODLGDrive))

'P$ = dr$ + D$ + s$
title(FODLGName) = s$
Refresh FODLGName

END IF
IF n = FODLGType AND iv = CChange THEN

D$ = fstr(title(FODLGDir))
DR$ = fstr$(title(FODLGDrive))

CALL GetFiles(DR$ + D$, FODLGFileArr, title(FODLGType))
Refresh FODLGFile
END IF

IF n = FODLGDrive AND iv = CLMouseClick THEN
CALL GetDrives(Drives())
s$ = ""
FOR i = 0 TO 25
IF Drives(i) = "" THEN EXIT FOR
s$ = s$ + Drives(i) + "   &"
NEXT
r = PopUpMenu(0, 0, s$, FODLGDrive, 0, 7)
IF r > 0 THEN
DR$ = Drives(r - 1)

ret = isdiskready(DR$)

IF ret THEN

CALL GetDirs(DR$, FODLGDirArr)
CALL GetFiles(DR$, FODLGFileArr, title(FODLGType))
title(FODLGDir) = ""
title(FODLGDrive) = DR$
title(FODLGFile) = ""
title(FODLGName) = ""
END IF

Refresh FileOpenDlgForm
END IF
END IF
IF n = FODLGFile AND iv = CLMouseDBLClick THEN
rr = CTR(n, rRow)
s$ = fstr(GetArrS(FODLGFileArr, rr))
D$ = fstr(title(FODLGDir))
DR$ = fstr(title(FODLGDrive))

p$ = DR$ + D$ + s$
'title(FODLGNAME) = s$
FileOpen$ = p$

DO
CALL mouse(MouseGet, C, C, b, C, C)
LOOP UNTIL b = 0

EXIT DO
END IF

IF n = FODLGOKButton AND iv = CLMouseClick THEN
s$ = fstr(title(FODLGName))
D$ = fstr(title(FODLGDir))
DR$ = fstr(title(FODLGDrive))

p$ = DR$ + D$ + s$

FileOpen$ = p$

EXIT DO
END IF

IF n = FODLGCancelButton AND iv = CLMouseClick THEN
FileOpen$ = ""
EXIT DO
END IF

IF n = FileOpenDlgForm AND iv = CFCLose THEN
FileOpen$ = ""
EXIT DO
END IF



moff
'PrintGFX 0, 400, STR$(n) + STR$(now) + STR$(ActiveForm(n)) + STR$(iv) + STR$(SysKey), 15, 0
LOOP UNTIL console = CHR$(27) 'AND (SysKey AND CKRShift)   'Emergency Exit

deletecontrol FileOpenDlgForm
oldf = loadlist(maxform)
CALL ExecutePrgEvent(Xk, yk, oldf, CFLoad)
Refresh 1


END FUNCTION

FUNCTION inputBox$ (titles$, Texts$, Default$)

TC = SysTColor
BC = SysBColor

Mx = GETMAXX
my = GETMAXY

Formmn = CreateForm(1, Mx / 2 - 150, my / 2 - 50, 305, 92, titles$)
n = Formmn
CTR(n, TColor) = TC
CTR(n, BColor) = BC
CTR(n, NoResize) = 1
CTR(n, NoMaximize) = 1
CTR(n, NoMinimize) = 1
CTR(n, Modal) = 1

f = OFrame
FrameMN = CreateControl(f, 1, Formmn, 0, 0, 240, 50, Texts$)
n = FrameMN
CTR(n, Borderstyle) = 0

f = OTextBox
TextMn = CreateControl(f, 1, Formmn, 1, 50, 240, 20, Default$)
n = TextMn
CTR(n, TextArray) = 0
title(n) = Default$


f = OButton
BtnYes = CreateControl(f, 1, Formmn, 245, 1, 52, 20, "Yes")
BtnNo = CreateControl(f, 1, Formmn, 245, 25, 52, 20, "No")

RegisterNewForm (Formmn)
CALL ExecutePrgEvent(Xk, yk, Formmn, CFLoad)
moff
DO
LoadForms

iv = waitforEvent
focus.objnewname = -1
IF iv <> CKeyPress THEN
         n = selectAllFocus
END IF
CALL ExecutePrgEvent(X, Y, n, iv)
'----------------------------------------
IF (iv = CKeyPress OR iv = CChange) AND console = CHR$(13) THEN
n = BtnYes
iv = CLMouseClick
END IF

IF (iv = CKeyPress OR iv = CChange) AND console = CHR$(27) THEN
console = ""
n = BtnNo
iv = CLMouseClick
END IF

IF iv = CLMouseClick AND n = BtnYes THEN
inputBox$ = RTRIM$(title(TextMn))

EXIT DO

END IF

IF iv = CLMouseClick AND n = BtnNo THEN
inputBox = ""
EXIT DO
END IF
IF iv = CFCLose AND n = Formmn THEN
inputBox = ""
EXIT DO
END IF

CALL moff

LOOP

deletecontrol Formmn
oldf = loadlist(maxform)
CALL ExecutePrgEvent(Xk, yk, oldf, CFLoad)
Refresh 1

END FUNCTION

FUNCTION MsgBox (titles$, Texts$, BtnStyle)

Mx = GETMAXX
my = GETMAXY

Formmn = CreateForm(1, Mx / 2 - 150, my / 2 - 50, 305, 92, titles$)
n = Formmn
CTR(n, NoResize) = 1
CTR(n, NoMaximize) = 1
CTR(n, NoMinimize) = 1
CTR(n, Modal) = 1

title(n) = titles$

FrameMN = CreateControl(OFrame, 1, Formmn, 1, 1, 240, 78, Texts$)
n = FrameMN

'ctr(n, BorderStyle) = 1'= CfrNoBorder

BtnYes = CreateControl(OButton, 1, Formmn, 245, 1, 52, 20, "Yes")

IF BtnStyle = CBYesNo OR BtnStyle = CBYesNoCancel THEN
BtnNo = CreateControl(OButton, 1, Formmn, 245, 25, 52, 20, "No")
END IF

IF BtnStyle = CBYesCancel OR BtnStyle = CBYesNoCancel THEN
BtnCancel = CreateControl(OButton, 1, Formmn, 245, 50, 52, 20, "Cancel")
END IF

RegisterNewForm (Formmn)
CALL ExecutePrgEvent(Xk, yk, Formmn, CFLoad)
moff
DO
LoadForms

iv = waitforEvent
focus.objnewname = -1
IF iv <> CKeyPress THEN
         n = selectAllFocus
END IF
CALL ExecutePrgEvent(X, Y, n, iv)
'----------------------------------------
IF iv = CKeyPress AND console = CHR$(13) THEN
n = BtnYes
iv = CLMouseClick
END IF

IF iv = CLMouseClick AND n = BtnYes THEN
MsgBox = 1
EXIT DO
END IF

IF iv = CLMouseClick AND n = BtnNo THEN
MsgBox = 2
EXIT DO
END IF
IF iv = CLMouseClick AND n = BtnCancel THEN
MsgBox = 3
EXIT DO
END IF
IF iv = CFCLose AND n = Formmn THEN
MsgBox = 3
EXIT DO
END IF

CALL moff

LOOP UNTIL console = CHR$(27)

deletecontrol Formmn
oldf = loadlist(maxform)
CALL ExecutePrgEvent(Xk, yk, oldf, CFLoad)
Refresh 1

END FUNCTION

FUNCTION PopUpList (arr, X, Y, XL, YL, Texts$)
Formmn = CreateForm(1, X, Y, XL, YL, Texts$)

CTR(Formmn, Visible) = 1

CTR(Formmn, NoMaximize) = 1
CTR(Formmn, NoMinimize) = 1
CTR(Formmn, NoResize) = 1
CTR(Formmn, NoClose) = 1
CTR(Formmn, Modal) = 1

f = OListBox
LISTMN = CreateControl(f, 1, Formmn, -2, 0, XL, YL - Hsize - 1, "")

CTR(LISTMN, NoSelect) = 3
CTR(LISTMN, scrollBar) = 1

mr = GetArrRows(arr)
mc = GetArrColls(arr)
arr1 = NewArray(mr, mc)
FOR i = 1 TO mr
CALL putarrs(arr1, i, GetArrS(arr, i))
NEXT
CTR(LISTMN, TextArray) = arr1

RegisterNewForm (Formmn)
CALL ExecutePrgEvent(Xk, yk, Formmn, CFLoad)
moff

DO
LoadForms
iv = waitforEvent
focus.objnewname = -1
IF iv <> CKeyPress THEN
         n = selectAllFocus
END IF

CALL ExecutePrgEvent(xx, yy, n, iv)

IF iv = CKeyPress AND console = CHR$(13) THEN
n = LISTMN
iv = CLMouseDBLClick
END IF

CALL mouse(MouseGet, Xmouse, Ymouse, LButton, RButton, C)
IF (Xmouse < CTR(Formmn, RLeft) OR Ymouse < CTR(Formmn, Rtop) OR Xmouse > CTR(Formmn, RLeft) + XL OR Ymouse > CTR(Formmn, Rtop) + YL) AND iv = CLMouseDown THEN
EXIT DO
END IF

IF n = LISTMN AND iv = CLMouseDBLClick THEN
PopUpList = CTR(LISTMN, rRow)
EXIT DO
END IF




'----------------------------------------
'CALL ExecuteUsrEvent(X, Y, N, iv)
CALL moff

LOOP UNTIL console = CHR$(27)

deletecontrol (Formmn)

oldf = loadlist(maxform)
CALL ExecutePrgEvent(Xk, yk, oldf, CFLoad)
console = ""
Refresh 1






END FUNCTION

FUNCTION PopUpMenu (xf, yf, A$, n, TC, BC)
X = xf + CTR(n, RLeft)
Y = yf + CTR(n, Rtop)
xx1 = 0: xx2 = 1


CALL mouse(MouseOff, C, C, C, C, C)


DIM mens$(20)
nn = 1
 nmk = 0
 FOR n1 = 1 TO LEN(A$)
 C$ = MID$(A$, n1, 1)
IF C$ = "&" THEN
         pr$ = MID$(A$, nn, n1 - nn)
        lp = LEN(pr$) * 8
        mens$(nmk) = pr$
        IF lmax < lp THEN lmax = lp
        XL = XL + lp
         nmk = nmk + 1
         nn = n1 + 1
END IF
pr$ = ""
NEXT n1

X1 = X + lmax + 10
Y1 = Y + nmk * 15 + 10

CALL DrawBorder(X, Y, X1, Y1, 15, BC, 8)
FOR i = 0 TO nmk
CALL PrintGFX(X + 5, Y + i * 15 + 5, mens$(i), TC, BC)
NEXT i
LButton = 0

as$ = ""
DO
CALL mouse(MouseOn, C, C, C, C, C)

DO
xmo = xm
ymo = ym
CALL mouse(MouseGet, Xmouse, Ymouse, LButton, RButton, C)
as$ = INKEY$
xm = (Xmouse - X + 5) \ 8
ym = (Ymouse - Y - 5) \ 15
LOOP UNTIL xmo <> xm OR ymo <> ym OR as$ = CHR$(27) OR LButton <> 0
CALL mouse(MouseOff, C, C, C, C, C)

IF xm > 0 AND xm <= lmax \ 8 + 1 AND ym >= -1 AND ym <= nmk THEN
FOR i1 = 0 TO nmk - 1
IF i1 = ym THEN
cc1 = BC: cc2 = TC
ELSE
cc2 = BC: cc1 = TC
END IF

'CALL drwfillbox(1, cc2, x + 2, y + i1 * 15 + 5, x + lmax + 7, y + i1 * 15 + 5 + 15)

CALL PrintGFX(X + 5, Y + i1 * 15 + 5, mens$(i1), cc1, cc2)
NEXT i1

IF LButton <> 0 THEN
PopUpMenu = ym + 1
Refresh (1)
ResetEvent = 1
EXIT FUNCTION
END IF

END IF

IF LButton <> 0 THEN
PopUpMenu = 0
Refresh (1)
ResetEvent = 1
EXIT FUNCTION
END IF

IF as$ = CHR$(27) THEN
PopUpMenu = 0
Refresh (1)
ResetEvent = 1
EXIT FUNCTION
END IF
LOOP

END FUNCTION

