'Module contains interface of XMS memory  and Whole Library
DEFINT A-Z
'$INCLUDE: 'Declare.bi'
'$INCLUDE: 'svgabc.bi'
'$INCLUDE: 'QB.bi'

COMMON SHARED Pal AS STRING * 768
DIM SHARED inreg AS RegTypeX, outreg AS RegTypeX

SUB applyfont (FontNumber)
n = FontNumber

IF n <= 0 THEN EXIT SUB
r = XMSGET(FontArray, 0, ni, 2)
IF ni < n THEN EXIT SUB

of& = 6000 * n - 6000 + 10

r = XMSGET(FontArray, of&, LI, 2)
l& = LI
IF l& / 2 <> l& \ 2 THEN l& = l& + 1
REDIM valu(l& \ 2)  AS INTEGER

r = XMSGET(FontArray, of& + 5, valu(0), l&)
s$ = num2str(valu())
s$ = MID$(s$, 1, LI)
CALL FONTSET(s$)
END SUB

SUB Bin (D, b1, b2, b3, b4, b5, b6, b7, b8)
i = D
b1 = i AND 128: IF b1 <> 0 THEN b1 = 1
b2 = i AND 64: IF b2 <> 0 THEN b2 = 1
b3 = i AND 32: IF b3 <> 0 THEN b3 = 1
b4 = i AND 16: IF b4 <> 0 THEN b4 = 1
b5 = i AND 8: IF b5 <> 0 THEN b5 = 1
b6 = i AND 4: IF b6 <> 0 THEN b6 = 1
b7 = i AND 2: IF b7 <> 0 THEN b7 = 1
b8 = i AND 1
END SUB

SUB Bin4 (D, bbbb1, bbbb2)
CALL Bin(D, b1, b2, b3, b4, b5, b6, b7, b8)
bbbb1 = b1 * 8 + b2 * 4 + b3 * 2 + b4
bbbb2 = b5 * 8 + b5 * 4 + b5 * 2 + b8
END SUB

FUNCTION BmpToArr (FileName$, C1)
DIM X AS LONG
DIM Y AS LONG
DIM XL AS LONG
DIM YL AS LONG
DIM null AS INTEGER
null = 0
s$ = " "
fl% = FREEFILE

OPEN FileName$ FOR BINARY AS fl%
IF LOF(fl%) < 2 THEN
CLOSE fl%
KILL FileName$
EXIT FUNCTION
END IF

GET fl%, 15, s$
infosize = ASC(s$)

GET fl%, 29, s$
nbits = ASC(s$)

'{Xlen}
s$ = "  "
GET fl%, 19, s$
XL = CVI(s$)

'{Ylen}
s$ = "  "
GET fl%, 23, s$
YL = CVI(s$)

'{----------------------}

IF nbits = 8 THEN
IF infosize = 40 THEN SEEK fl%, 1078
IF infosize = 12 THEN SEEK fl%, 794
n = (2048 - XL)
n1 = n \ 4
nn = n - n1 * 4
IF nn = 3 THEN V = 2
IF nn = 2 THEN V = 1
IF nn = 1 THEN V = 1
IF nn = 0 THEN V = 0
IF nn = 4 THEN V = 0

REDIM XLIN(XL \ 2)  AS INTEGER
h% = XMSBLKGET(1, 1, XL, YL)

FOR Y = YL TO 1 STEP -1
FOR X = 0 TO XL \ 2 + V - 1'+ v1
GET fl%, , s$

cc = ASC(s$) + C1
IF cc > 255 THEN cc = 255
XLIN(X) = CVI(CHR$(cc) + CHR$(cc))

NEXT
r = XMSPUT(XLIN(0), h%, Y * XL + 8, XL)

NEXT
BmpToArr = h%
END IF

IF nbits = 4 THEN
s$ = " "
IF infosize = 40 THEN SEEK fl%, 119
IF infosize = 12 THEN SEEK fl%, 74

n = (2048 - XL)
n1 = n \ 8
nn = n - n1 * 8
IF nn = 0 OR nn = 8 THEN V = 0
IF nn = 1 OR nn = 2 THEN V = 1
IF nn = 3 OR nn = 4 THEN V = 2
IF nn = 5 OR nn = 6 THEN V = 3
IF nn = 7 THEN V = 4

REDIM XLIN(XL \ 2)  AS INTEGER

h% = XMSBLKGET(1, 1, XL, YL)
l = XL * YL / 1000

lxi = INT(XL) - 1
lyi = INT(YL) - 1
LI = INT(XL * YL) + 8
FOR Y = YL TO 0 STEP -1
FOR X = 0 TO XL \ 2 + V - 1 STEP 1
GET fl%, , s$
cc = ASC(s$)
CALL Bin4(cc, b1, b2)
b11 = (cc AND 15) + C1
b22 = b1 + C1

IF b22 > 255 THEN b22 = 255
IF b11 > 255 THEN b11 = 255

XLIN(X) = CVI(CHR$(b22) + CHR$(b11))
NEXT
r = XMSPUT(XLIN(0), h%, Y * XL - XL + 8, XL)
NEXT

BmpToArr = h%
END IF
IF nbits = 1 THEN
IF infosize = 40 THEN SEEK fl%, 62
IF infosize = 12 THEN SEEK fl%, 32
END IF
CLOSE fl%


END FUNCTION

FUNCTION Dec (b1, b2, b3, b4, b5, b6, b7, b8)
Dec = b1 * 128 + b2 * 64 + b3 * 32 + b4 * 16 + b5 * 8 + b6 * 4 + b7 * 2 + b8
END FUNCTION

SUB EndP
CLS
SCREEN 12
SCREEN 0
CLS
END
END SUB

FUNCTION GetArrColls (Array)
r = XMSGET(Array, 3, siz, 2)

GetArrColls = siz
END FUNCTION

FUNCTION GetArrRows (Array)

r = XMSGET(Array, 6, siz, 2)
GetArrRows = siz

END FUNCTION

FUNCTION GetArrS$ (Array, n)
IF Array = 0 THEN
 ERROR 38
END IF
sl& = GetArrColls(Array)
IF sl& / 2 <> sl& \ 2 THEN sl& = sl& + 1

REDIM valu(sl& \ 2)  AS INTEGER

of& = n
of& = of& * sl& + 10
r = XMSGET(Array, of&, valu(0), sl&)

GetArrS$ = fstr(num2str(valu()))

END FUNCTION

SUB GetBMPSize (FileName$, XL, YL, NColors)
fl% = FREEFILE
OPEN FileName$ FOR BINARY AS fl%
IF LOF(fl%) < 2 THEN
CLOSE fl%
KILL FileName$
EXIT SUB
END IF

s$ = "  "
GET fl%, 19, s$
XL = CVI(s$)
s$ = "  "
GET fl%, 23, s$
YL = CVI(s$)

GET fl%, 15, s$
infosize = ASC(s$)
GET fl%, 29, s$
nbits = ASC(s$)
   IF nbits = 1 THEN
   NColors = 2
   END IF
   IF nbits = 4 THEN
   NColors = 16
   END IF
   IF nbits = 8 THEN
   NColors = 256
   END IF
CLOSE fl%
END SUB

FUNCTION GetCurDir$
'-----------Remember current drive--------
   inreg.ax = &H1900
   CALL INTERRUPTX(&H21, inreg, outreg)
   cd = (outreg.ax AND 255) + 1
'-----------Get drives--------

'cd = 4
DIM Buffer(128)

aseg = VARSEG(Buffer(0))
aptr = VARPTR(Buffer(0))

inreg.ax = &H4700
inreg.dx = cd
inreg.ds = aseg
inreg.si = aptr
CALL INTERRUPTX(&H21, inreg, outreg)
IF outreg.ax = 15 THEN
ERROR 68       'no such drive
ELSE
DEF SEG = aseg
FOR A = 0 TO 128
f$ = f$ + CHR$(PEEK(aptr + A))
NEXT
DEF SEG
s$ = CHR$(cd + 64) + ":\" + LEFT$(f$, INSTR(f$, CHR$(0)) - 1)
IF LEFT$(s$, 1) <> "\" THEN s$ = s$ + "\"
GetCurDir$ = s$
END IF

END FUNCTION

SUB GetDirs (Directory$, ar)
inreg.cx = 16 + 1 + 2 + 4 + 128 + 64'(215)
inreg.ax = &H4E00
FMask$ = Directory$ + "*.*" + CHR$(0)
inreg.ds = VARSEG(FMask$)
inreg.dx = SADD(FMask$)
CALL INTERRUPTX(&H21, inreg, outreg)
'IF OutReg.flags AND (OutReg.ax = 2 OR OutReg.ax = &H12) THEN EXIT SUB '᫨ a  -  室.
con = 1
DO
inreg.ax = &H2F00
CALL INTERRUPTX(&H21, inreg, outreg)
DEF SEG = outreg.es
FileName$ = ""
FOR i = &H1E TO &H2A
symbol$ = CHR$(PEEK(outreg.bx + i))
IF symbol$ = CHR$(0) THEN EXIT FOR
FileName$ = FileName$ + symbol$
NEXT
IF FileName$ <> "." THEN

dir$ = UCASE$(FileName$)
CALL putarrs(ar, con, dir$)
con = con + 1
END IF
inreg.ax = &H4F00
inreg.cx = 215
CALL INTERRUPTX(&H21, inreg, outreg)
LOOP UNTIL (outreg.flags AND (outreg.ax = 2 OR outreg.ax = &H12))

FOR n = con TO GetArrRows(ar)
CALL putarrs(ar, n, " ")
NEXT n

END SUB

SUB GetDrives (Drives() AS STRING)
'-----------Remember current drive--------
     inreg.ax = &H1900
          CALL INTERRUPTX(&H21, inreg, outreg)
          cd = (outreg.ax AND 255)
          '-----------Get drives--------

FOR i = 1 TO 25
        DrNumber = i
    IF DrNumber >= 0 AND DrNumber <= 25 THEN
      inreg.ax = &HE00
      inreg.dx = DrNumber
    
      CALL INTERRUPTX(&H21, inreg, outreg)
      inreg.ax = &H1900
     CALL INTERRUPTX(&H21, inreg, outreg)
      IF DrNumber <> (outreg.ax AND 255) THEN
        'PRINT
      ELSE
      'PRINT "Drive "; DrNumber; " Exists"
      c$ = CHR$(i + 64) + ":\"
      IF c$ <> "B:\" THEN
      Drives(k) = c$
      k = k + 1
      END IF
      END IF
  
    END IF
NEXT
'-----------Return current drive--------
      inreg.ax = &HE00
            inreg.dx = cd
                  CALL INTERRUPTX(&H21, inreg, outreg)


END SUB

SUB GetFiles (Directory$, ar, Mask$)
inreg.ax = &H4E00
inreg.cx = (2 ^ 0 + 2 ^ 1 + 2 ^ 2 + 2 ^ 5) '(39)
FMask$ = Directory$ + Mask$ + CHR$(0)
inreg.ds = VARSEG(FMask$)
inreg.dx = SADD(FMask$)
con = 1
CALL INTERRUPTX(&H21, inreg, outreg)
'IF OutReg.flags AND (OutReg.ax = 2 OR OutReg.ax = &H12) THEN EXIT SUB
DO UNTIL (outreg.flags AND (outreg.ax = 3 OR outreg.ax = &H12))
inreg.ax = &H2F00
CALL INTERRUPTX(&H21, inreg, outreg)
DEF SEG = outreg.es
FileName$ = ""
FOR i = &H1E TO &H2A
symbol$ = CHR$(PEEK(outreg.bx + i))
IF symbol$ = CHR$(0) THEN EXIT FOR
FileName$ = FileName$ + symbol$
NEXT

fls$ = UCASE$(FileName$)
CALL putarrs(ar, con, fls$)
con = con + 1
inreg.ax = &H4F00
inreg.cx = 39
CALL INTERRUPTX(&H21, inreg, outreg)

LOOP

FOR i = con TO GetArrRows(ar)
CALL putarrs(ar, i, " ")
NEXT i
'CALL putarrs(ar, 0, Directory$)
END SUB

FUNCTION GetFontHeight (FontNumber)
n = FontNumber

IF n < 0 THEN EXIT FUNCTION
IF n = 0 THEN
GetFontHeight = 16
EXIT FUNCTION
END IF
r = XMSGET(FontArray, 0, ni, 2)
IF ni < n THEN EXIT FUNCTION

of& = 6000 * n - 6000 + 10

r = XMSGET(FontArray, of&, LI, 2)
l& = LI
IF l& / 2 <> l& \ 2 THEN l& = l& + 1
REDIM valu(l& \ 2)  AS INTEGER

r = XMSGET(FontArray, of& + 5, valu(0), l&)
s$ = num2str(valu())
GetFontHeight = ASC(MID$(s$, 2, 1))

END FUNCTION

FUNCTION GetMyName$

  inreg.ax = &H6200
  INTERRUPTX &H21, inreg, outreg
  PSPStart% = outreg.bx

  DEF SEG = PSPStart%
  EnvironStart% = PEEK(&H2D) * 256 + PEEK(&H2C)
  DEF SEG

  DEF SEG = EnvironStart%
  DO
    Char = PEEK(A)
    IF Char = 0 THEN
      A = A + 1
      Char = PEEK(A)
      IF Char = 0 THEN
        Found = 1
      END IF
    END IF
    A = A + 1
  LOOP UNTIL Found = 1
  A = A + 2
  Found = False
  DO
    Char = PEEK(A)
    IF Char = 0 THEN
      Found = 1
    ELSE
      Path$ = Path$ + CHR$(Char)
    END IF
    A = A + 1
  LOOP UNTIL Found = 1
  DEF SEG
  GetMyName$ = Path$


END FUNCTION

SUB insertLines (Array, StartRow, NRows)
ac& = GetArrColls(Array)
IF ac& / 2 <> ac& \ 2 THEN ac& = ac& + 1

ar& = GetArrRows(Array)
nr& = NRows
sr& = StartRow
nxs = (ac& * ar& \ 1000)
ar2 = XMSALLOCATE(nxs)
st& = sr& * ac& + 10
ln& = ac& * ar& - st&
r = XMSCOPY(Array, 0, ar2, 0, ar& * ac&)
r = XMSCOPY(ar2, st&, Array, st& + nr& * ac&, ln&)
FOR i = sr& TO sr& + nr& - 1
CALL putarrs(Array, i, STRING$(ac&, CHR$(0)))
NEXT
r = XMSFREE(ar2)
END SUB

FUNCTION isdiskready (Drive$)

Dr = ASC(UCASE$(MID$(Drive$, 1, 1))) - 64
inreg.ax = &H1C00
 inreg.dx = Dr
 INTERRUPTX &H21, inreg, outreg
 IF outreg.bx = 0 THEN
 isdiskready = 0
 ELSE
    isdiskready = NOT (0)
 END IF





END FUNCTION

FUNCTION LoadBMP (n, FileName$, C1, C2)
GetBMPSize FileName$, XL, YL, NColors

CTR(n, Rows) = YL
CTR(n, Colls) = XL
SetBmpPalette FileName$, C1, C2

CTR(n, TextArray) = BmpToArr(FileName$, C1)

END FUNCTION

SUB LoadData (FileName$, arr, sn, Mask$)
f% = FREEFILE
OPEN FileName$ FOR INPUT AS f%
DO UNTIL EOF(f%)
INPUT #f%, s$

IF UCASE$(MID$(s$, 1, LEN(Mask$))) = UCASE$(Mask$) THEN
n = sn

DO UNTIL s$ = "<END>"
LINE INPUT #f%, s$
IF UCASE$(s$) <> "<END>" THEN
CALL putarrs(arr, n, s$)
END IF
n = n + 1
LOOP
EXIT DO



END IF
LOOP
CLOSE f%

END SUB

FUNCTION LoadFont (FileName$)
OPEN FileName$ FOR BINARY AS #1
lk = LOF(1)
s$ = SPACE$(lk)
GET #1, 1, s$
CLOSE 1
l& = lk
IF l& / 2 <> l& \ 2 THEN l& = l& + 1
REDIM valu(l& \ 2) AS INTEGER

CALL STR2NUM(valu(), s$)

r = XMSGET(FontArray, 0, n, 2)
n = n + 1
r = XMSPUT(n, FontArray, 0, 2)
of& = 6000 * n - 6000 + 10
r = XMSPUT(lk, FontArray, of&, 2)
r = XMSPUT(valu(0), FontArray, of& + 5, l&)
LoadFont = n


END FUNCTION

FUNCTION NewArray (NRows, nColls)
DO
dll& = nColls
dll& = dll& * NRows
dl = dll& \ 1000 + 1
h = XMSALLOCATE(dl)
r = XMSPUT(ASC("s"), h, 0, 2)
r = XMSPUT(nColls, h, 3, 2)
r = XMSPUT(NRows, h, 6, 2)
FOR i = 1 TO NRows
CALL putarrs(h, i, STRING$(nColls, CHR$(0)))
NEXT
IF h <> 0 THEN
EXIT DO
ELSE
r = XMSFREE(h)
r = XMSALLOCATE(2)
END IF
LOOP
NewArray = h

END FUNCTION

FUNCTION num2str$ (valuen())
FOR i = 0 TO UBOUND(valuen)
D = valuen(i)
s$ = MKI$(D)
values$ = values$ + s$
NEXT

IF RIGHT$(values$, 1) = CHR$(0) THEN values$ = MID$(values$, 1, LEN(values$) - 1)
num2str$ = values$

END FUNCTION

SUB putarrs (Array, n, Value$)
IF Array = 0 THEN
 ERROR 38
END IF
sl& = GetArrColls(Array)

IF sl& / 2 <> sl& \ 2 THEN sl& = sl& + 1

REDIM valu(sl& \ 2)  AS INTEGER
s$ = STRING$(sl&, CHR$(0))

'-------
IF LEN(Value$) > sl& THEN
ERROR 14
END IF

MID$(s$, 1, LEN(Value$)) = Value$

CALL STR2NUM(valu(), Value$)

of& = n
of& = of& * sl& + 10

r = XMSPUT(valu(0), Array, of&, sl&)

END SUB

SUB removeLines (Array, StartRow, NRows)
ac& = GetArrColls(Array)
IF ac& / 2 <> ac& \ 2 THEN ac& = ac& + 1

ar& = GetArrRows(Array)
nr& = NRows
sr& = StartRow
nxs = (ac& * ar& \ 1000)
ar2 = XMSALLOCATE(nxs)
st& = sr& * ac& + 10
ln& = ac& * ar& - st&
IF ln& > 0 THEN
r = XMSCOPY(Array, 0, ar2, 0, ar& * ac&)
r = XMSCOPY(ar2, st& + nr& * ac&, Array, st&, ln&)
END IF
r = XMSFREE(ar2)

END SUB

SUB SetBmpPalette (FileName$, C1, C2)
PALGET Pal, 16, 255
s$ = " "
fl% = FREEFILE
OPEN FileName$ FOR BINARY AS fl%
IF LOF(fl%) < 2 THEN
CLOSE fl%
KILL FileName$
EXIT SUB
END IF
GET fl%, 15, s$
infosize = ASC(s$)
GET fl%, 29, s$
nbits = ASC(s$)

IF infosize = 12 THEN
   IF nbits = 1 THEN
   sm = 253
   pallen = 6
   END IF
   IF nbits = 4 THEN
   sm = 234
   pallen = 42
   END IF
   IF nbits = 8 THEN
   sm = 16
   En = 16
   pallen = 768
   END IF
A = pallen / 3
END IF

IF infosize = 40 THEN
   IF nbits = 1 THEN
   pallen = 8
   sm = 253
   END IF
   IF nbits = 4 THEN
   pallen = 64
   sm = 234
   En = 0
   END IF
   IF nbits = 8 THEN
   pallen = 1024
   sm = 16
   En = 16
  
   END IF
A = pallen / 4
END IF

SEEK fl%, infosize + 15
X = 0
DO
IF X >= A - En - 1 THEN EXIT DO
GET fl%, , s$
B = ASC(s$) \ 4
GET #fl%, , s$
g = ASC(s$) \ 4
GET fl%, , s$
r = ASC(s$) \ 4
GET fl%, , s$
'IF (B + r + g) <> 0 THEN
of = (C1 + X) * 3
IF of < 765 THEN
MID$(Pal, of + 1, 1) = CHR$(r)
MID$(Pal, of + 2, 1) = CHR$(g)
MID$(Pal, of + 3, 1) = CHR$(B)
END IF
X = X + 1
'END IF

LOOP
mk = C1 + A
IF mk > 255 THEN mk = 255
PALSET Pal, C1, mk
CLOSE fl%
END SUB

SUB SplitPath (Path$, Drive$, Dire$, file$, ext$)
s$ = Path$
LL = LEN(s$)
l = LL
IF l < 1 THEN EXIT SUB
'------------------------------------

FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = "." THEN
extl = LL - i + 1
ext$ = RIGHT$(s$, extl)
l = i - 1
EXIT FOR
END IF
NEXT
'-----------------------------------
FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = "\" THEN
file$ = MID$(s$, i + 1, l - i)
filel = l - i - 1
l = i
EXIT FOR
END IF
NEXT
IF (filel = 0) AND (LL > extl) THEN
file$ = LEFT$(s$, l)
filel = LEN(file$)
END IF

'---------------------------

FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = ":" THEN
Dire$ = MID$(s$, i + 2, l - i - 1)
Drive$ = LEFT$(s$, i + 1)
pathl = l - i - 1
l = i
EXIT FOR
END IF
NEXT

IF (pathl = 0) AND (LL > extl + filel) AND (MID$(s$, l, 1) <> ":") THEN
Dire$ = LEFT$(s$, l)

END IF
'-----------------------------------


END SUB

SUB STR2NUM (valuen(), values$)

FOR i = 1 TO LEN(values$) STEP 2
s$ = MID$(values$, i, 2)

IF LEN(s$) = 2 THEN
D = CVI(s$)
valuen(k&) = D
k& = k& + 1
END IF
IF LEN(s$) = 1 THEN
D = CVI(s$ + CHR$(0))

valuen(k&) = D
k& = k& + 1
END IF

NEXT

END SUB

